#include "common.h"

void GetInfo();
char * GetPlatformInfo(const cl_platform_id platform, 
  const cl_platform_info param_name);

char Buff[50];

int main() {
  GetInfo();
  return 0;
}

void GetInfo() {
  cl_int err;
  cl_uint numPlatforms;

  err = clGetPlatformIDs(0, NULL, &numPlatforms);
  CHECK_ERROR(err, "clGetPlatformIDs");
  cout << numPlatforms << " platform(s)" << endl;
  if(numPlatforms > 0) {
    cl_platform_id *platforms = new cl_platform_id[numPlatforms];
    err = clGetPlatformIDs(numPlatforms, platforms, NULL);
    CHECK_ERROR(err, "clGetPlatformIDs");
    
    for(cl_uint i = 0; i < numPlatforms; i++) {
      cout << "Platform Id : " << i << endl;
      cout << "CL_PLATFORM_PROFILE : " << 
        GetPlatformInfo(platforms[i], CL_PLATFORM_PROFILE) << endl;
      cout << "CL_PLATFORM_VERSION : " << 
        GetPlatformInfo(platforms[i], CL_PLATFORM_VERSION) << endl;
      cout << "CL_PLATFORM_NAME : " << 
        GetPlatformInfo(platforms[i], CL_PLATFORM_NAME) << endl;
      cout << "CL_PLATFORM_VENDOR : " << 
        GetPlatformInfo(platforms[i], CL_PLATFORM_VENDOR) << endl;
      cout << "CL_PLATFORM_EXTENSIONS : " << 
        GetPlatformInfo(platforms[i], CL_PLATFORM_EXTENSIONS) << endl;
      cout << endl;
    }
    delete platforms;
  }
}

char * GetPlatformInfo(const cl_platform_id platform, 
  const cl_platform_info param_name) {
  
  cl_int err;
  err = clGetPlatformInfo(platform, param_name, sizeof(Buff), 
    Buff, NULL);
  CHECK_ERROR(err, "clGetPlatformInfo");
  return Buff;
}
