#include "common.h"

void GetInfo();
char * GetPlatformInfo(const cl_platform_id platform, 
  const cl_platform_info param_name);
char * GetDeviceInfo(const cl_device_id device, 
  const cl_device_info param_name);

char Buff[1000];

int main() {
  GetInfo();
  return 0;
}

void GetInfo() {
  cl_int err;
  cl_uint numPlatforms;

  err = clGetPlatformIDs(0, NULL, &numPlatforms);
  CHECK_ERROR(err, "clGetPlatformIDs");
  cout << numPlatforms << " platform(s)" << endl;
  if(numPlatforms > 0) {
    cl_platform_id *platforms = new cl_platform_id[numPlatforms];
    err = clGetPlatformIDs(numPlatforms, platforms, NULL);
    CHECK_ERROR(err, "clGetPlatformIDs");
    
    cl_uint i;
    for(i = 0; i < numPlatforms; i++) {
      cout << "Platform Id : " << i << endl;
      cout << "CL_PLATFORM_PROFILE : " << 
        GetPlatformInfo(platforms[i], CL_PLATFORM_PROFILE) << endl;
      cout << "CL_PLATFORM_VERSION : " << 
        GetPlatformInfo(platforms[i], CL_PLATFORM_VERSION) << endl;
      cout << "CL_PLATFORM_NAME : " << 
        GetPlatformInfo(platforms[i], CL_PLATFORM_NAME) << endl;
      cout << "CL_PLATFORM_VENDOR : " << 
        GetPlatformInfo(platforms[i], CL_PLATFORM_VENDOR) << endl;
      cout << "CL_PLATFORM_EXTENSIONS : " << 
        GetPlatformInfo(platforms[i], CL_PLATFORM_EXTENSIONS) << endl;
      cout << endl;
    
      cl_uint numDevices;
      err = clGetDeviceIDs(platforms[i], CL_DEVICE_TYPE_ALL, 0, 
        NULL, &numDevices);
      CHECK_ERROR(err, "clGetDeviceIDs");
      cout << numDevices << " device(s)" << endl;
      if(numDevices > 0) {
        cl_device_id* devices = new cl_device_id[numDevices];
        err = clGetDeviceIDs(platforms[i], CL_DEVICE_TYPE_ALL, 
          numDevices, devices, &numDevices);
        CHECK_ERROR(err, "clGetDeviceIDs");
        for(cl_uint j = 0; j < numDevices; j++) {
          cout << "Device ID : " << j << endl;
          cout << "CL_DEVICE_NAME : " << 
            GetDeviceInfo(devices[j], CL_DEVICE_NAME) << endl;
          cout << "CL_DEVICE_PROFILE : " << 
            GetDeviceInfo(devices[j], CL_DEVICE_PROFILE) << endl;
          cout << "CL_DEVICE_VENDOR : " << 
            GetDeviceInfo(devices[j], CL_DEVICE_VENDOR) << endl;
          cout << "CL_DEVICE_VERSION : " << 
            GetDeviceInfo(devices[j], CL_DEVICE_VERSION) << endl;
          cout << "CL_DRIVER_VERSION : " << 
            GetDeviceInfo(devices[j], CL_DRIVER_VERSION) << endl;
          cout << "CL_DEVICE_OPENCL_C_VERSION : " << 
            GetDeviceInfo(devices[j], CL_DEVICE_OPENCL_C_VERSION) 
            << endl;
          cout << "CL_DEVICE_EXTENSIONS : " << 
            GetDeviceInfo(devices[j], CL_DEVICE_EXTENSIONS) << endl;
          cout << endl;
        }
        delete devices;
      }
    }
    delete platforms;
  }
}

char * GetPlatformInfo(const cl_platform_id platform, 
  const cl_platform_info param_name) {
  
  cl_int err;
  err = clGetPlatformInfo(platform, param_name, sizeof(Buff), 
    Buff, NULL);
  CHECK_ERROR(err, "clGetPlatformInfo");
  return Buff;
}

char * GetDeviceInfo(const cl_device_id device, 
  const cl_device_info param_name) {
  
  cl_int err;
  err = clGetDeviceInfo(device, param_name, sizeof(Buff), 
    Buff, NULL);
  CHECK_ERROR(err, "clGetDeviceInfo");
  return Buff;
}
