#include "common.hpp"

int main() {
  cl_int err;
  cl_uint counter;
  
  vector<cl::Platform> platforms;
  err = cl::Platform::get(&platforms);
  CHECK_ERROR(err, "Platform::get");
  
  cout << platforms.size() << " platform(s)" << endl;
  if(platforms.size() > 0) {
    counter = 0;
    for(vector<cl::Platform>::iterator i = platforms.begin();
      i != platforms.end(); i++) {
      cout << "Platform " << counter++ << endl;
      cout << "CL_PLATFORM_PROFILE : " << 
        (*i).getInfo<CL_PLATFORM_PROFILE>(&err).c_str() << endl;
      CHECK_ERROR(err, "Platform::getInfo");
      cout << "CL_PLATFORM_VERSION : " << 
        (*i).getInfo<CL_PLATFORM_VERSION>(&err).c_str() << endl;
      CHECK_ERROR(err, "Platform::getInfo");
      cout << "CL_PLATFORM_NAME : " << 
        (*i).getInfo<CL_PLATFORM_NAME>(&err).c_str() << endl;
      CHECK_ERROR(err, "Platform::getInfo");
      cout << "CL_PLATFORM_VENDOR : " << 
        (*i).getInfo<CL_PLATFORM_VENDOR>(&err).c_str() << endl;
      CHECK_ERROR(err, "Platform::getInfo");
      cout << "CL_PLATFORM_EXTENSIONS : " << 
        (*i).getInfo<CL_PLATFORM_EXTENSIONS>(&err).c_str() << endl;
      CHECK_ERROR(err, "Platform::getInfo");
      cout << endl;

      vector<cl::Device> devices;
      err = (*i).getDevices(CL_DEVICE_TYPE_ALL, &devices);
      CHECK_ERROR(err, "Platform::getDevices");
      cout << devices.size() << " device(s)" << endl;
      counter = 0;
      for(vector<cl::Device>::iterator i = devices.begin();
        i != devices.end(); i++) {
        cout << "Device " << counter++ << endl;
        cout << "CL_DEVICE_NAME : " << 
          (*i).getInfo<CL_DEVICE_NAME>(&err).c_str() << endl;
        CHECK_ERROR(err, "Device::getInfo");
        cout << "CL_DEVICE_PROFILE : " << 
          (*i).getInfo<CL_DEVICE_PROFILE>(&err).c_str() << endl;
        CHECK_ERROR(err, "Device::getInfo");
        cout << "CL_DEVICE_VENDOR : " << 
          (*i).getInfo<CL_DEVICE_VENDOR>(&err).c_str() << endl;
        CHECK_ERROR(err, "Device::getInfo");
        cout << "CL_DEVICE_VERSION : " << 
          (*i).getInfo<CL_DEVICE_VERSION>(&err).c_str() << endl;
        CHECK_ERROR(err, "Device::getInfo");
        cout << "CL_DRIVER_VERSION : " << 
          (*i).getInfo<CL_DRIVER_VERSION>(&err).c_str() << endl;
        CHECK_ERROR(err, "Device::getInfo");
        cout << "CL_DEVICE_OPENCL_C_VERSION : " << 
          (*i).getInfo<CL_DEVICE_OPENCL_C_VERSION>(&err).c_str() << endl;
        CHECK_ERROR(err, "Device::getInfo");
        cout << "CL_DEVICE_EXTENSIONS : " << 
          (*i).getInfo<CL_DEVICE_EXTENSIONS>(&err).c_str() << endl;
        CHECK_ERROR(err, "Device::getInfo");
        cout << "CL_DEVICE_MAX_WORK_ITEM_DIMENSIONS : " << 
          (*i).getInfo<CL_DEVICE_MAX_WORK_ITEM_DIMENSIONS>(&err) << endl;
        CHECK_ERROR(err, "Device::getInfo");
        cout << "CL_DEVICE_MAX_WORK_ITEM_SIZES[0] : " << 
          (*i).getInfo<CL_DEVICE_MAX_WORK_ITEM_SIZES>(&err)[0] << endl;
        CHECK_ERROR(err, "Device::getInfo");
        cout << "CL_DEVICE_MAX_WORK_ITEM_SIZES[1] : " << 
          (*i).getInfo<CL_DEVICE_MAX_WORK_ITEM_SIZES>(&err)[1] << endl;
        CHECK_ERROR(err, "Device::getInfo");
        cout << "CL_DEVICE_MAX_WORK_ITEM_SIZES[2] : " << 
          (*i).getInfo<CL_DEVICE_MAX_WORK_ITEM_SIZES>(&err)[2] << endl;
        CHECK_ERROR(err, "Device::getInfo");
        cout << "CL_DEVICE_MAX_WORK_GROUP_SIZE : " << 
          (*i).getInfo<CL_DEVICE_MAX_WORK_GROUP_SIZE>(&err) << endl;
        CHECK_ERROR(err, "Device::getInfo");
        cout << endl;
      }
    }
  }
  return 0;
}
