#ifndef __COMMON_HPP__
#define __COMMON_HPP__
#define __NO_STD_STRING

#include <iostream>
#include <CL/cl.hpp>
using namespace std;

static void CheckError(const cl_int err, const char *message, 
  const char *file, const int line) {
  
  if (err != CL_SUCCESS) {
    cout << file << "("  << line << ") Error : " << message << endl;
    exit(EXIT_FAILURE);
  }
}
#define CHECK_ERROR(err, message) (CheckError(err, message, __FILE__, __LINE__))

#define CHECK_NOT_NULL(p) { \
  if (p == NULL) { \
    cout << __FILE__ << "(" << __LINE__ << ")" << "Error : the pointer is NULL" << endl; \
    exit(EXIT_FAILURE);}}

#endif
