#ifndef __COMMON_HPP__
#define __COMMON_HPP__
#include <iostream>
using namespace std;

static void CheckError(cudaError_t err, const char *file, int line) {
  if (err != cudaSuccess) {
    cout << file << "("  << line << ") Error : " << 
      cudaGetErrorString(err) << endl;
    exit(EXIT_FAILURE);
  }
}
#define CHECK_ERROR(err) (CheckError(err, __FILE__, __LINE__))
#define CHECK_NOT_NULL(p) { \
  if (p == NULL) { \
    cout << __FILE__ << "(" << __LINE__ << ")" << \
      "Error : the pointer is NULL" << endl; \
    exit(EXIT_FAILURE);}}
#endif
