#include "common.hpp"

int main() {
  int deviceCount;
  cudaDeviceProp dp;

  CHECK_ERROR(cudaGetDeviceCount(&deviceCount));
  for (int i = 0; i < deviceCount; i++) {
    CHECK_ERROR(cudaGetDeviceProperties(&dp, i));
    cout << endl << "[device " << i << ']' << endl;
    cout << "name : " << dp.name << endl;
    cout << "multiProcessorCount : " << dp.multiProcessorCount << endl;
    cout << "totalGlobalMem : " << dp.totalGlobalMem << endl;
    cout << "ECCEnabled : " << dp.ECCEnabled << endl;
    cout << "Compute Capability : " << dp.major << '.' << 
      dp.minor << endl;
    cout << "maxThreadsPerBlock : " << dp.maxThreadsPerBlock << endl;
    cout << "maxThreadsDim : (" << dp.maxThreadsDim[0] << ',' <<
      dp.maxThreadsDim[1] << ',' << dp.maxThreadsDim[2] << ')' << endl;
    cout << "maxGridSize : (" << dp.maxGridSize[0] << ',' <<
      dp.maxGridSize[1] << ',' << dp.maxGridSize[2] <<  ')' << endl;
  }
  return 0;
}
